<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AffiliateSiteInfo StructType
 * @subpackage Structs
 */
class AffiliateSiteInfo extends AbstractStructBase
{
    /**
     * The type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var \StructType\AffiliateSiteType
     */
    public $type;
    /**
     * The category
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var \StructType\AffiliateSiteCategory
     */
    public $category;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $description;
    /**
     * The creationDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $creationDate;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $status;
    /**
     * Constructor method for AffiliateSiteInfo
     * @uses AffiliateSiteInfo::setType()
     * @uses AffiliateSiteInfo::setCategory()
     * @uses AffiliateSiteInfo::setDescription()
     * @uses AffiliateSiteInfo::setCreationDate()
     * @uses AffiliateSiteInfo::setStatus()
     * @param \StructType\AffiliateSiteType $type
     * @param \StructType\AffiliateSiteCategory $category
     * @param string $description
     * @param string $creationDate
     * @param string $status
     */
    public function __construct(\StructType\AffiliateSiteType $type = null, \StructType\AffiliateSiteCategory $category = null, $description = null, $creationDate = null, $status = null)
    {
        $this
            ->setType($type)
            ->setCategory($category)
            ->setDescription($description)
            ->setCreationDate($creationDate)
            ->setStatus($status);
    }
    /**
     * Get type value
     * @return \StructType\AffiliateSiteType|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param \StructType\AffiliateSiteType $type
     * @return \StructType\AffiliateSiteInfo
     */
    public function setType(\StructType\AffiliateSiteType $type = null)
    {
        $this->type = $type;
        return $this;
    }
    /**
     * Get category value
     * @return \StructType\AffiliateSiteCategory|null
     */
    public function getCategory()
    {
        return $this->category;
    }
    /**
     * Set category value
     * @param \StructType\AffiliateSiteCategory $category
     * @return \StructType\AffiliateSiteInfo
     */
    public function setCategory(\StructType\AffiliateSiteCategory $category = null)
    {
        $this->category = $category;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\AffiliateSiteInfo
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get creationDate value
     * @return string|null
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }
    /**
     * Set creationDate value
     * @param string $creationDate
     * @return \StructType\AffiliateSiteInfo
     */
    public function setCreationDate($creationDate = null)
    {
        // validation for constraint: string
        if (!is_null($creationDate) && !is_string($creationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($creationDate, true), gettype($creationDate)), __LINE__);
        }
        $this->creationDate = $creationDate;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @uses \EnumType\AffiliateSiteStatus::valueIsValid()
     * @uses \EnumType\AffiliateSiteStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $status
     * @return \StructType\AffiliateSiteInfo
     */
    public function setStatus($status = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AffiliateSiteStatus::valueIsValid($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AffiliateSiteStatus', is_array($status) ? implode(', ', $status) : var_export($status, true), implode(', ', \EnumType\AffiliateSiteStatus::getValidValues())), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AffiliateSiteInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
