<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CampaignCommission StructType
 * @subpackage Structs
 */
class CampaignCommission extends AbstractStructBase
{
    /**
     * The impressionCommission
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var float
     */
    public $impressionCommission;
    /**
     * The clickCommission
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var float
     */
    public $clickCommission;
    /**
     * The fixedCommission
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var float
     */
    public $fixedCommission;
    /**
     * The leadCommission
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var float
     */
    public $leadCommission;
    /**
     * The saleCommissionFixed
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var float
     */
    public $saleCommissionFixed;
    /**
     * The saleCommissionVariable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var float
     */
    public $saleCommissionVariable;
    /**
     * The iLeadCommission
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var float
     */
    public $iLeadCommission;
    /**
     * The iSaleCommissionFixed
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var float
     */
    public $iSaleCommissionFixed;
    /**
     * The iSaleCommissionVariable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var float
     */
    public $iSaleCommissionVariable;
    /**
     * Constructor method for CampaignCommission
     * @uses CampaignCommission::setImpressionCommission()
     * @uses CampaignCommission::setClickCommission()
     * @uses CampaignCommission::setFixedCommission()
     * @uses CampaignCommission::setLeadCommission()
     * @uses CampaignCommission::setSaleCommissionFixed()
     * @uses CampaignCommission::setSaleCommissionVariable()
     * @uses CampaignCommission::setILeadCommission()
     * @uses CampaignCommission::setISaleCommissionFixed()
     * @uses CampaignCommission::setISaleCommissionVariable()
     * @param float $impressionCommission
     * @param float $clickCommission
     * @param float $fixedCommission
     * @param float $leadCommission
     * @param float $saleCommissionFixed
     * @param float $saleCommissionVariable
     * @param float $iLeadCommission
     * @param float $iSaleCommissionFixed
     * @param float $iSaleCommissionVariable
     */
    public function __construct($impressionCommission = null, $clickCommission = null, $fixedCommission = null, $leadCommission = null, $saleCommissionFixed = null, $saleCommissionVariable = null, $iLeadCommission = null, $iSaleCommissionFixed = null, $iSaleCommissionVariable = null)
    {
        $this
            ->setImpressionCommission($impressionCommission)
            ->setClickCommission($clickCommission)
            ->setFixedCommission($fixedCommission)
            ->setLeadCommission($leadCommission)
            ->setSaleCommissionFixed($saleCommissionFixed)
            ->setSaleCommissionVariable($saleCommissionVariable)
            ->setILeadCommission($iLeadCommission)
            ->setISaleCommissionFixed($iSaleCommissionFixed)
            ->setISaleCommissionVariable($iSaleCommissionVariable);
    }
    /**
     * Get impressionCommission value
     * @return float|null
     */
    public function getImpressionCommission()
    {
        return $this->impressionCommission;
    }
    /**
     * Set impressionCommission value
     * @param float $impressionCommission
     * @return \StructType\CampaignCommission
     */
    public function setImpressionCommission($impressionCommission = null)
    {
        // validation for constraint: float
        if (!is_null($impressionCommission) && !(is_float($impressionCommission) || is_numeric($impressionCommission))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($impressionCommission, true), gettype($impressionCommission)), __LINE__);
        }
        $this->impressionCommission = $impressionCommission;
        return $this;
    }
    /**
     * Get clickCommission value
     * @return float|null
     */
    public function getClickCommission()
    {
        return $this->clickCommission;
    }
    /**
     * Set clickCommission value
     * @param float $clickCommission
     * @return \StructType\CampaignCommission
     */
    public function setClickCommission($clickCommission = null)
    {
        // validation for constraint: float
        if (!is_null($clickCommission) && !(is_float($clickCommission) || is_numeric($clickCommission))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($clickCommission, true), gettype($clickCommission)), __LINE__);
        }
        $this->clickCommission = $clickCommission;
        return $this;
    }
    /**
     * Get fixedCommission value
     * @return float|null
     */
    public function getFixedCommission()
    {
        return $this->fixedCommission;
    }
    /**
     * Set fixedCommission value
     * @param float $fixedCommission
     * @return \StructType\CampaignCommission
     */
    public function setFixedCommission($fixedCommission = null)
    {
        // validation for constraint: float
        if (!is_null($fixedCommission) && !(is_float($fixedCommission) || is_numeric($fixedCommission))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($fixedCommission, true), gettype($fixedCommission)), __LINE__);
        }
        $this->fixedCommission = $fixedCommission;
        return $this;
    }
    /**
     * Get leadCommission value
     * @return float|null
     */
    public function getLeadCommission()
    {
        return $this->leadCommission;
    }
    /**
     * Set leadCommission value
     * @param float $leadCommission
     * @return \StructType\CampaignCommission
     */
    public function setLeadCommission($leadCommission = null)
    {
        // validation for constraint: float
        if (!is_null($leadCommission) && !(is_float($leadCommission) || is_numeric($leadCommission))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($leadCommission, true), gettype($leadCommission)), __LINE__);
        }
        $this->leadCommission = $leadCommission;
        return $this;
    }
    /**
     * Get saleCommissionFixed value
     * @return float|null
     */
    public function getSaleCommissionFixed()
    {
        return $this->saleCommissionFixed;
    }
    /**
     * Set saleCommissionFixed value
     * @param float $saleCommissionFixed
     * @return \StructType\CampaignCommission
     */
    public function setSaleCommissionFixed($saleCommissionFixed = null)
    {
        // validation for constraint: float
        if (!is_null($saleCommissionFixed) && !(is_float($saleCommissionFixed) || is_numeric($saleCommissionFixed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($saleCommissionFixed, true), gettype($saleCommissionFixed)), __LINE__);
        }
        $this->saleCommissionFixed = $saleCommissionFixed;
        return $this;
    }
    /**
     * Get saleCommissionVariable value
     * @return float|null
     */
    public function getSaleCommissionVariable()
    {
        return $this->saleCommissionVariable;
    }
    /**
     * Set saleCommissionVariable value
     * @param float $saleCommissionVariable
     * @return \StructType\CampaignCommission
     */
    public function setSaleCommissionVariable($saleCommissionVariable = null)
    {
        // validation for constraint: float
        if (!is_null($saleCommissionVariable) && !(is_float($saleCommissionVariable) || is_numeric($saleCommissionVariable))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($saleCommissionVariable, true), gettype($saleCommissionVariable)), __LINE__);
        }
        $this->saleCommissionVariable = $saleCommissionVariable;
        return $this;
    }
    /**
     * Get iLeadCommission value
     * @return float|null
     */
    public function getILeadCommission()
    {
        return $this->iLeadCommission;
    }
    /**
     * Set iLeadCommission value
     * @param float $iLeadCommission
     * @return \StructType\CampaignCommission
     */
    public function setILeadCommission($iLeadCommission = null)
    {
        // validation for constraint: float
        if (!is_null($iLeadCommission) && !(is_float($iLeadCommission) || is_numeric($iLeadCommission))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($iLeadCommission, true), gettype($iLeadCommission)), __LINE__);
        }
        $this->iLeadCommission = $iLeadCommission;
        return $this;
    }
    /**
     * Get iSaleCommissionFixed value
     * @return float|null
     */
    public function getISaleCommissionFixed()
    {
        return $this->iSaleCommissionFixed;
    }
    /**
     * Set iSaleCommissionFixed value
     * @param float $iSaleCommissionFixed
     * @return \StructType\CampaignCommission
     */
    public function setISaleCommissionFixed($iSaleCommissionFixed = null)
    {
        // validation for constraint: float
        if (!is_null($iSaleCommissionFixed) && !(is_float($iSaleCommissionFixed) || is_numeric($iSaleCommissionFixed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($iSaleCommissionFixed, true), gettype($iSaleCommissionFixed)), __LINE__);
        }
        $this->iSaleCommissionFixed = $iSaleCommissionFixed;
        return $this;
    }
    /**
     * Get iSaleCommissionVariable value
     * @return float|null
     */
    public function getISaleCommissionVariable()
    {
        return $this->iSaleCommissionVariable;
    }
    /**
     * Set iSaleCommissionVariable value
     * @param float $iSaleCommissionVariable
     * @return \StructType\CampaignCommission
     */
    public function setISaleCommissionVariable($iSaleCommissionVariable = null)
    {
        // validation for constraint: float
        if (!is_null($iSaleCommissionVariable) && !(is_float($iSaleCommissionVariable) || is_numeric($iSaleCommissionVariable))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($iSaleCommissionVariable, true), gettype($iSaleCommissionVariable)), __LINE__);
        }
        $this->iSaleCommissionVariable = $iSaleCommissionVariable;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CampaignCommission
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
