<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConversionTransaction StructType
 * @subpackage Structs
 */
class ConversionTransaction extends AbstractStructBase
{
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var int
     */
    public $ID;
    /**
     * The campaign
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var \StructType\Campaign
     */
    public $campaign;
    /**
     * The affiliateSite
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var \StructType\AffiliateSite
     */
    public $affiliateSite;
    /**
     * The campaignProduct
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var \StructType\CampaignProduct
     */
    public $campaignProduct;
    /**
     * The reference
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $reference;
    /**
     * The transactionType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $transactionType;
    /**
     * The transactionStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $transactionStatus;
    /**
     * The numTouchPointsTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $numTouchPointsTotal;
    /**
     * The numTouchPointsAttributed
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $numTouchPointsAttributed;
    /**
     * The attributableCommission
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $attributableCommission;
    /**
     * The characteristic
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $characteristic;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $description;
    /**
     * The currency
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $currency;
    /**
     * The commission
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var float
     */
    public $commission;
    /**
     * The orderAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var float
     */
    public $orderAmount;
    /**
     * The IP
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $IP;
    /**
     * The registrationDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $registrationDate;
    /**
     * The assessmentDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $assessmentDate;
    /**
     * The clickToConversion
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $clickToConversion;
    /**
     * The originatingClickDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $originatingClickDate;
    /**
     * The rejectionReason
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $rejectionReason;
    /**
     * The paidOut
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var bool
     */
    public $paidOut;
    /**
     * The affiliateSitesPaidOut
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var \StructType\AffiliateSitesPaidOut
     */
    public $affiliateSitesPaidOut;
    /**
     * The countryCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $countryCode;
    /**
     * The attributionModel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * @var string
     */
    public $attributionModel;
    /**
     * Constructor method for ConversionTransaction
     * @uses ConversionTransaction::setID()
     * @uses ConversionTransaction::setCampaign()
     * @uses ConversionTransaction::setAffiliateSite()
     * @uses ConversionTransaction::setCampaignProduct()
     * @uses ConversionTransaction::setReference()
     * @uses ConversionTransaction::setTransactionType()
     * @uses ConversionTransaction::setTransactionStatus()
     * @uses ConversionTransaction::setNumTouchPointsTotal()
     * @uses ConversionTransaction::setNumTouchPointsAttributed()
     * @uses ConversionTransaction::setAttributableCommission()
     * @uses ConversionTransaction::setCharacteristic()
     * @uses ConversionTransaction::setDescription()
     * @uses ConversionTransaction::setCurrency()
     * @uses ConversionTransaction::setCommission()
     * @uses ConversionTransaction::setOrderAmount()
     * @uses ConversionTransaction::setIP()
     * @uses ConversionTransaction::setRegistrationDate()
     * @uses ConversionTransaction::setAssessmentDate()
     * @uses ConversionTransaction::setClickToConversion()
     * @uses ConversionTransaction::setOriginatingClickDate()
     * @uses ConversionTransaction::setRejectionReason()
     * @uses ConversionTransaction::setPaidOut()
     * @uses ConversionTransaction::setAffiliateSitesPaidOut()
     * @uses ConversionTransaction::setCountryCode()
     * @uses ConversionTransaction::setAttributionModel()
     * @param int $iD
     * @param \StructType\Campaign $campaign
     * @param \StructType\AffiliateSite $affiliateSite
     * @param \StructType\CampaignProduct $campaignProduct
     * @param string $reference
     * @param string $transactionType
     * @param string $transactionStatus
     * @param int $numTouchPointsTotal
     * @param int $numTouchPointsAttributed
     * @param float $attributableCommission
     * @param string $characteristic
     * @param string $description
     * @param string $currency
     * @param float $commission
     * @param float $orderAmount
     * @param string $iP
     * @param string $registrationDate
     * @param string $assessmentDate
     * @param string $clickToConversion
     * @param string $originatingClickDate
     * @param string $rejectionReason
     * @param bool $paidOut
     * @param \StructType\AffiliateSitesPaidOut $affiliateSitesPaidOut
     * @param string $countryCode
     * @param string $attributionModel
     */
    public function __construct($iD = null, \StructType\Campaign $campaign = null, \StructType\AffiliateSite $affiliateSite = null, \StructType\CampaignProduct $campaignProduct = null, $reference = null, $transactionType = null, $transactionStatus = null, $numTouchPointsTotal = null, $numTouchPointsAttributed = null, $attributableCommission = null, $characteristic = null, $description = null, $currency = null, $commission = null, $orderAmount = null, $iP = null, $registrationDate = null, $assessmentDate = null, $clickToConversion = null, $originatingClickDate = null, $rejectionReason = null, $paidOut = null, \StructType\AffiliateSitesPaidOut $affiliateSitesPaidOut = null, $countryCode = null, $attributionModel = null)
    {
        $this
            ->setID($iD)
            ->setCampaign($campaign)
            ->setAffiliateSite($affiliateSite)
            ->setCampaignProduct($campaignProduct)
            ->setReference($reference)
            ->setTransactionType($transactionType)
            ->setTransactionStatus($transactionStatus)
            ->setNumTouchPointsTotal($numTouchPointsTotal)
            ->setNumTouchPointsAttributed($numTouchPointsAttributed)
            ->setAttributableCommission($attributableCommission)
            ->setCharacteristic($characteristic)
            ->setDescription($description)
            ->setCurrency($currency)
            ->setCommission($commission)
            ->setOrderAmount($orderAmount)
            ->setIP($iP)
            ->setRegistrationDate($registrationDate)
            ->setAssessmentDate($assessmentDate)
            ->setClickToConversion($clickToConversion)
            ->setOriginatingClickDate($originatingClickDate)
            ->setRejectionReason($rejectionReason)
            ->setPaidOut($paidOut)
            ->setAffiliateSitesPaidOut($affiliateSitesPaidOut)
            ->setCountryCode($countryCode)
            ->setAttributionModel($attributionModel);
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\ConversionTransaction
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !(is_int($iD) || ctype_digit($iD))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get campaign value
     * @return \StructType\Campaign|null
     */
    public function getCampaign()
    {
        return $this->campaign;
    }
    /**
     * Set campaign value
     * @param \StructType\Campaign $campaign
     * @return \StructType\ConversionTransaction
     */
    public function setCampaign(\StructType\Campaign $campaign = null)
    {
        $this->campaign = $campaign;
        return $this;
    }
    /**
     * Get affiliateSite value
     * @return \StructType\AffiliateSite|null
     */
    public function getAffiliateSite()
    {
        return $this->affiliateSite;
    }
    /**
     * Set affiliateSite value
     * @param \StructType\AffiliateSite $affiliateSite
     * @return \StructType\ConversionTransaction
     */
    public function setAffiliateSite(\StructType\AffiliateSite $affiliateSite = null)
    {
        $this->affiliateSite = $affiliateSite;
        return $this;
    }
    /**
     * Get campaignProduct value
     * @return \StructType\CampaignProduct|null
     */
    public function getCampaignProduct()
    {
        return $this->campaignProduct;
    }
    /**
     * Set campaignProduct value
     * @param \StructType\CampaignProduct $campaignProduct
     * @return \StructType\ConversionTransaction
     */
    public function setCampaignProduct(\StructType\CampaignProduct $campaignProduct = null)
    {
        $this->campaignProduct = $campaignProduct;
        return $this;
    }
    /**
     * Get reference value
     * @return string|null
     */
    public function getReference()
    {
        return $this->reference;
    }
    /**
     * Set reference value
     * @param string $reference
     * @return \StructType\ConversionTransaction
     */
    public function setReference($reference = null)
    {
        // validation for constraint: string
        if (!is_null($reference) && !is_string($reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reference, true), gettype($reference)), __LINE__);
        }
        $this->reference = $reference;
        return $this;
    }
    /**
     * Get transactionType value
     * @return string|null
     */
    public function getTransactionType()
    {
        return $this->transactionType;
    }
    /**
     * Set transactionType value
     * @uses \EnumType\TransactionType::valueIsValid()
     * @uses \EnumType\TransactionType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $transactionType
     * @return \StructType\ConversionTransaction
     */
    public function setTransactionType($transactionType = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\TransactionType::valueIsValid($transactionType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\TransactionType', is_array($transactionType) ? implode(', ', $transactionType) : var_export($transactionType, true), implode(', ', \EnumType\TransactionType::getValidValues())), __LINE__);
        }
        $this->transactionType = $transactionType;
        return $this;
    }
    /**
     * Get transactionStatus value
     * @return string|null
     */
    public function getTransactionStatus()
    {
        return $this->transactionStatus;
    }
    /**
     * Set transactionStatus value
     * @uses \EnumType\TransactionStatus::valueIsValid()
     * @uses \EnumType\TransactionStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $transactionStatus
     * @return \StructType\ConversionTransaction
     */
    public function setTransactionStatus($transactionStatus = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\TransactionStatus::valueIsValid($transactionStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\TransactionStatus', is_array($transactionStatus) ? implode(', ', $transactionStatus) : var_export($transactionStatus, true), implode(', ', \EnumType\TransactionStatus::getValidValues())), __LINE__);
        }
        $this->transactionStatus = $transactionStatus;
        return $this;
    }
    /**
     * Get numTouchPointsTotal value
     * @return int|null
     */
    public function getNumTouchPointsTotal()
    {
        return $this->numTouchPointsTotal;
    }
    /**
     * Set numTouchPointsTotal value
     * @param int $numTouchPointsTotal
     * @return \StructType\ConversionTransaction
     */
    public function setNumTouchPointsTotal($numTouchPointsTotal = null)
    {
        // validation for constraint: int
        if (!is_null($numTouchPointsTotal) && !(is_int($numTouchPointsTotal) || ctype_digit($numTouchPointsTotal))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numTouchPointsTotal, true), gettype($numTouchPointsTotal)), __LINE__);
        }
        $this->numTouchPointsTotal = $numTouchPointsTotal;
        return $this;
    }
    /**
     * Get numTouchPointsAttributed value
     * @return int|null
     */
    public function getNumTouchPointsAttributed()
    {
        return $this->numTouchPointsAttributed;
    }
    /**
     * Set numTouchPointsAttributed value
     * @param int $numTouchPointsAttributed
     * @return \StructType\ConversionTransaction
     */
    public function setNumTouchPointsAttributed($numTouchPointsAttributed = null)
    {
        // validation for constraint: int
        if (!is_null($numTouchPointsAttributed) && !(is_int($numTouchPointsAttributed) || ctype_digit($numTouchPointsAttributed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numTouchPointsAttributed, true), gettype($numTouchPointsAttributed)), __LINE__);
        }
        $this->numTouchPointsAttributed = $numTouchPointsAttributed;
        return $this;
    }
    /**
     * Get attributableCommission value
     * @return float|null
     */
    public function getAttributableCommission()
    {
        return $this->attributableCommission;
    }
    /**
     * Set attributableCommission value
     * @param float $attributableCommission
     * @return \StructType\ConversionTransaction
     */
    public function setAttributableCommission($attributableCommission = null)
    {
        // validation for constraint: float
        if (!is_null($attributableCommission) && !(is_float($attributableCommission) || is_numeric($attributableCommission))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($attributableCommission, true), gettype($attributableCommission)), __LINE__);
        }
        $this->attributableCommission = $attributableCommission;
        return $this;
    }
    /**
     * Get characteristic value
     * @return string|null
     */
    public function getCharacteristic()
    {
        return $this->characteristic;
    }
    /**
     * Set characteristic value
     * @param string $characteristic
     * @return \StructType\ConversionTransaction
     */
    public function setCharacteristic($characteristic = null)
    {
        // validation for constraint: string
        if (!is_null($characteristic) && !is_string($characteristic)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($characteristic, true), gettype($characteristic)), __LINE__);
        }
        $this->characteristic = $characteristic;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\ConversionTransaction
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get currency value
     * @return string|null
     */
    public function getCurrency()
    {
        return $this->currency;
    }
    /**
     * Set currency value
     * @param string $currency
     * @return \StructType\ConversionTransaction
     */
    public function setCurrency($currency = null)
    {
        // validation for constraint: string
        if (!is_null($currency) && !is_string($currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currency, true), gettype($currency)), __LINE__);
        }
        $this->currency = $currency;
        return $this;
    }
    /**
     * Get commission value
     * @return float|null
     */
    public function getCommission()
    {
        return $this->commission;
    }
    /**
     * Set commission value
     * @param float $commission
     * @return \StructType\ConversionTransaction
     */
    public function setCommission($commission = null)
    {
        // validation for constraint: float
        if (!is_null($commission) && !(is_float($commission) || is_numeric($commission))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($commission, true), gettype($commission)), __LINE__);
        }
        $this->commission = $commission;
        return $this;
    }
    /**
     * Get orderAmount value
     * @return float|null
     */
    public function getOrderAmount()
    {
        return $this->orderAmount;
    }
    /**
     * Set orderAmount value
     * @param float $orderAmount
     * @return \StructType\ConversionTransaction
     */
    public function setOrderAmount($orderAmount = null)
    {
        // validation for constraint: float
        if (!is_null($orderAmount) && !(is_float($orderAmount) || is_numeric($orderAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($orderAmount, true), gettype($orderAmount)), __LINE__);
        }
        $this->orderAmount = $orderAmount;
        return $this;
    }
    /**
     * Get IP value
     * @return string|null
     */
    public function getIP()
    {
        return $this->IP;
    }
    /**
     * Set IP value
     * @param string $iP
     * @return \StructType\ConversionTransaction
     */
    public function setIP($iP = null)
    {
        // validation for constraint: string
        if (!is_null($iP) && !is_string($iP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iP, true), gettype($iP)), __LINE__);
        }
        $this->IP = $iP;
        return $this;
    }
    /**
     * Get registrationDate value
     * @return string|null
     */
    public function getRegistrationDate()
    {
        return $this->registrationDate;
    }
    /**
     * Set registrationDate value
     * @param string $registrationDate
     * @return \StructType\ConversionTransaction
     */
    public function setRegistrationDate($registrationDate = null)
    {
        // validation for constraint: string
        if (!is_null($registrationDate) && !is_string($registrationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($registrationDate, true), gettype($registrationDate)), __LINE__);
        }
        $this->registrationDate = $registrationDate;
        return $this;
    }
    /**
     * Get assessmentDate value
     * @return string|null
     */
    public function getAssessmentDate()
    {
        return $this->assessmentDate;
    }
    /**
     * Set assessmentDate value
     * @param string $assessmentDate
     * @return \StructType\ConversionTransaction
     */
    public function setAssessmentDate($assessmentDate = null)
    {
        // validation for constraint: string
        if (!is_null($assessmentDate) && !is_string($assessmentDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($assessmentDate, true), gettype($assessmentDate)), __LINE__);
        }
        $this->assessmentDate = $assessmentDate;
        return $this;
    }
    /**
     * Get clickToConversion value
     * @return string|null
     */
    public function getClickToConversion()
    {
        return $this->clickToConversion;
    }
    /**
     * Set clickToConversion value
     * @param string $clickToConversion
     * @return \StructType\ConversionTransaction
     */
    public function setClickToConversion($clickToConversion = null)
    {
        // validation for constraint: string
        if (!is_null($clickToConversion) && !is_string($clickToConversion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clickToConversion, true), gettype($clickToConversion)), __LINE__);
        }
        $this->clickToConversion = $clickToConversion;
        return $this;
    }
    /**
     * Get originatingClickDate value
     * @return string|null
     */
    public function getOriginatingClickDate()
    {
        return $this->originatingClickDate;
    }
    /**
     * Set originatingClickDate value
     * @param string $originatingClickDate
     * @return \StructType\ConversionTransaction
     */
    public function setOriginatingClickDate($originatingClickDate = null)
    {
        // validation for constraint: string
        if (!is_null($originatingClickDate) && !is_string($originatingClickDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originatingClickDate, true), gettype($originatingClickDate)), __LINE__);
        }
        $this->originatingClickDate = $originatingClickDate;
        return $this;
    }
    /**
     * Get rejectionReason value
     * @return string|null
     */
    public function getRejectionReason()
    {
        return $this->rejectionReason;
    }
    /**
     * Set rejectionReason value
     * @uses \EnumType\TransactionRejectionReason::valueIsValid()
     * @uses \EnumType\TransactionRejectionReason::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $rejectionReason
     * @return \StructType\ConversionTransaction
     */
    public function setRejectionReason($rejectionReason = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\TransactionRejectionReason::valueIsValid($rejectionReason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\TransactionRejectionReason', is_array($rejectionReason) ? implode(', ', $rejectionReason) : var_export($rejectionReason, true), implode(', ', \EnumType\TransactionRejectionReason::getValidValues())), __LINE__);
        }
        $this->rejectionReason = $rejectionReason;
        return $this;
    }
    /**
     * Get paidOut value
     * @return bool|null
     */
    public function getPaidOut()
    {
        return $this->paidOut;
    }
    /**
     * Set paidOut value
     * @param bool $paidOut
     * @return \StructType\ConversionTransaction
     */
    public function setPaidOut($paidOut = null)
    {
        // validation for constraint: boolean
        if (!is_null($paidOut) && !is_bool($paidOut)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($paidOut, true), gettype($paidOut)), __LINE__);
        }
        $this->paidOut = $paidOut;
        return $this;
    }
    /**
     * Get affiliateSitesPaidOut value
     * @return \StructType\AffiliateSitesPaidOut|null
     */
    public function getAffiliateSitesPaidOut()
    {
        return $this->affiliateSitesPaidOut;
    }
    /**
     * Set affiliateSitesPaidOut value
     * @param \StructType\AffiliateSitesPaidOut $affiliateSitesPaidOut
     * @return \StructType\ConversionTransaction
     */
    public function setAffiliateSitesPaidOut(\StructType\AffiliateSitesPaidOut $affiliateSitesPaidOut = null)
    {
        $this->affiliateSitesPaidOut = $affiliateSitesPaidOut;
        return $this;
    }
    /**
     * Get countryCode value
     * @return string|null
     */
    public function getCountryCode()
    {
        return $this->countryCode;
    }
    /**
     * Set countryCode value
     * @param string $countryCode
     * @return \StructType\ConversionTransaction
     */
    public function setCountryCode($countryCode = null)
    {
        // validation for constraint: string
        if (!is_null($countryCode) && !is_string($countryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryCode, true), gettype($countryCode)), __LINE__);
        }
        $this->countryCode = $countryCode;
        return $this;
    }
    /**
     * Get attributionModel value
     * @return string|null
     */
    public function getAttributionModel()
    {
        return $this->attributionModel;
    }
    /**
     * Set attributionModel value
     * @uses \EnumType\CampaignAttributionModel::valueIsValid()
     * @uses \EnumType\CampaignAttributionModel::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $attributionModel
     * @return \StructType\ConversionTransaction
     */
    public function setAttributionModel($attributionModel = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\CampaignAttributionModel::valueIsValid($attributionModel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\CampaignAttributionModel', is_array($attributionModel) ? implode(', ', $attributionModel) : var_export($attributionModel, true), implode(', ', \EnumType\CampaignAttributionModel::getValidValues())), __LINE__);
        }
        $this->attributionModel = $attributionModel;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ConversionTransaction
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
